VERSION 5.00
Begin VB.UserControl ucDownload 
   BackColor       =   &H0080FF80&
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   585
   ScaleHeight     =   480
   ScaleWidth      =   585
End
Attribute VB_Name = "ucDownload"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ----------------------------------------------------------------------------------
' \\ -- Eventos
' ----------------------------------------------------------------------------------

Event AsyncProgress(BytesMax As Long, BytesRead As Long)             ' -- Progreso
Event DownloadComplet(vData As Variant, AsyncProp As AsyncProperty)  ' -- Fin
Event InitDownload()                                                 ' -- Antes de llamar al mtodo AsyncRead


' ----------------------------------------------------------------------------------
' \\ -- Sub que recibe la url y comienza la descarga
' ----------------------------------------------------------------------------------
Public Sub DownloadFile(ByVal Url As String)
    
    On Error GoTo error_handler
    ' -- Lanzar evento de inicio
    RaiseEvent InitDownload
    
    ' -- Pasar la URL
    Call AsyncRead(Url, vbAsyncTypeByteArray, Url, vbAsyncReadForceUpdate)
    Exit Sub
error_handler:
MsgBox Err.Number & vbNewLine & Err.Description, vbCritical
End Sub

' ----------------------------------------------------------------------------------
' \\ -- Progreso de la descarga
' ----------------------------------------------------------------------------------

Private Sub UserControl_AsyncReadProgress(AsyncProp As AsyncProperty)
On Error GoTo error_handler
    ' -- Enviar los valores
    RaiseEvent AsyncProgress(AsyncProp.BytesMax, AsyncProp.BytesRead)

    Exit Sub

error_handler:
    MsgBox Err.Number & vbNewLine & Err.Description, vbCritical
    
End Sub

' ----------------------------------------------------------------------------------
' \\ -- Fin de la descarga
' ----------------------------------------------------------------------------------

Private Sub UserControl_AsyncReadComplete(AsyncProp As AsyncProperty)
    On Error GoTo error_handler
    
    ' -- Enviar el array de bytes, y el objeto AsyncProp
    RaiseEvent DownloadComplet(AsyncProp.Value, AsyncProp)
    
    Exit Sub

error_handler:
    MsgBox Err.Number & vbNewLine & Err.Description, vbCritical

End Sub
